/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef ALGORITHM_UNIQUE_HPP
#define ALGORITHM_UNIQUE_HPP 1

#include <iterator>
#include <set>

namespace algorithm
{
  
  template < typename Iterator >
  auto unique (Iterator begin, Iterator end)
  {
    using value_type = typename std::iterator_traits<Iterator>::value_type;
    using set_type = std::set<value_type>;
    return set_type(begin,end);
  }

  template < typename Range >
  auto unique (Range const range)
  { return algorithm::unique(begin(range),end(range)); }

} // namespace algorithm

#endif
