/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef ASYNCHRONOUS_SIGNALS_TYPE_DEFAULT_SIGNAL_EXECUTOR_IS_SEQUENTIAL_HPP
#define ASYNCHRONOUS_SIGNALS_TYPE_DEFAULT_SIGNAL_EXECUTOR_IS_SEQUENTIAL_HPP 1

#include <asynchronous/signals/type/default_signal_executor_fwd.hpp>
#include <asynchronous/signals/sequential_signal_executor.hpp>

namespace asynchronous
{

  namespace signals
  {

    namespace type
    {

      template < typename Tag >
      struct default_signal_executor
      {
	template < typename Signature, typename Combiner, typename SignalTag >
	struct apply
	{
	  using type = sequential_signal_executor<Signature,Combiner,SignalTag>;
	};
      };

    } // namespace type

  } // namespace signals

} // namespace asynchronous

#include <asynchronous/signals/signal.hpp>

#endif
