/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_DISTRIBUTION_SCALAR_DISTRIBUTION_POLICY_HPP
#define GRAPH_MODEL_DISTRIBUTION_SCALAR_DISTRIBUTION_POLICY_HPP 1

#include <graph_model/distribution/distribution_policy.hpp>

namespace graph_model
{

  namespace distribution
  {

    template < typename DistributionPolicy
	       , typename GeneratorPolicy
	       >
    class scalar_distribution_policy
      : public distribution_policy<DistributionPolicy,GeneratorPolicy>
    {
      using self = scalar_distribution_policy;

    public:
      template < typename Variate, typename ... Parameters >
      static auto eval_cdf (Variate variate, Parameters ... parameters)
      {
	auto distribution = self::template distribution<Variate>(parameters...);
	return cdf(distribution,variate);
      }
    };

  } // namespace distribution

} // namespace graph_model

#endif
