/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_UTILITY_TYPE_INVOCATION_POLICY_HPP
#define GRAPH_MODEL_UTILITY_TYPE_INVOCATION_POLICY_HPP 1

#include <graph_model/utility/type/invocation_policy_fwd.hpp>
#include <graph_model/utility/default_invocation_policy.hpp>
#include <use_default.hpp>

namespace graph_model
{

  namespace utility
  {

    namespace type
    {

      template < typename InvocationPolicy >
      struct default_invocation_policy
      {
	using type = InvocationPolicy;
      };

      template <>
      struct default_invocation_policy< use_default<> >
      {
	using type = utility::default_invocation_policy;
      };

      template < typename InvocationPolicy >
      struct invocation_policy
	: default_invocation_policy<InvocationPolicy>
      {};

    } // namespace type

  } // namespace utility

} // namespace graph_model

#endif
